/*
 *   Copyright (C) Charles Shapiro 1997-1999 72300.3632@compuserve.com
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 * Routines needed all over the coldread program.
 *
 *  Charles Shapiro 5 Jun 1999
 */
#include <stdio.h>
#include <string.h>

#define EXTERNAL extern
#include "crstructs.h"


/*
 * Walk down the key list looking for a matching key word
 */
keylist *findWordInKeyList(const char *word)
{
  keylist *retVal=Keyword_pile;

  while((retVal) && (0 != strcmp(retVal->keyword,word)) )
    retVal=retVal->next_kw;

  return retVal;
}
/*
 * Set up the auto keywords. These store interesting values, but have
 * no sentences associated with them.
 */
void setAutoKeywords(keylist *Keypile)
{
  make_keyword(KWTOTAL);
  make_keyword(KWAVERAGE);
  make_keyword(KWNUMBER);
}
/*
 * Initialize global data pointers to 0
 */
void initGlobalData(void)
{
  SentenceSequence=0;
  Sequence=0;
  Keyword_pile=0;
  Current_keyword=0;
  setAutoKeywords(Keyword_pile);
  Expression_pile=0;
  Current_expression=0;
  Relationship_pile=0;
  Current_relationship=0;

  return;
}

/*
 * Find the sentenceNumberth sentence in sentenceList.
 */
sentence *findSentence(int sentenceNumber,sentence *sentenceList)
{
  struct senc *retVal=(struct senc *)sentenceList;

  while(retVal && sentenceNumber)
  {
    --sentenceNumber;
    if(sentenceNumber)
      retVal=retVal->next_sentence;
  }
  return (sentence *)retVal;

}

/*
 * Add a keyword to the list of keywords.
 */
int make_keyword(char *newkeyword)
{
   if(! Keyword_pile)
   {
	Keyword_pile=(keylist *)calloc(1,sizeof(keylist));
	Current_keyword=Keyword_pile;
   } 
   else
   {
     Current_keyword->next_kw=(keylist *)calloc(1,sizeof(keylist));
     Current_keyword=Current_keyword->next_kw;
   }

   Current_keyword->sequence_number=Sequence;
   ++Sequence;
   Current_keyword->keyword=strdup(newkeyword);

   return 1;
}
